void module(ArrayList mainList, int mainPick)
{
  noStroke();

  IntList incoming_data = new IntList();
  IntList culled_data = new IntList();
  IntList culled_data_sorted = new IntList();
  IntDict pairedData = new IntDict();
  IntDict paired_dewey_numbers = new IntDict();
  IntDict paired_values = new IntDict(); 

  incoming_data = (IntList)mainList.get(mainPick);

  float avg = 0;
  float avg_picks = 0;
  int sum = 0;
  int sum_picks = 0;
  float max = incoming_data.max();
  float startAngle = -0.8;

  // create a dictionary to keep track of where the values belong to
  // key = # of checkouts, value = dewey # (-630)
  for (int i = 0; i < numColumns; i++) {
    pairedData.set(str(i), incoming_data.get(i));
    sum += incoming_data.get(i);
  }

  // cull data as per user definition
  for (int i = 0; i < column_picks.size(); i++) {
    String the_data = str(column_picks.get(i));
    culled_data.append(pairedData.get(the_data));
    culled_data_sorted.append(pairedData.get(the_data));
    sum_picks += pairedData.get(the_data);
    paired_dewey_numbers.set(str(pairedData.get(the_data)), column_picks.get(i));
  }
  // println(paired_dewey_numbers);

  // make a dictionary where key = SORTED checkout val, value = dewey # 
  culled_data_sorted.sortReverse();
  for (int i = 0; i < column_picks.size(); i++) {
    paired_values.set(str(culled_data_sorted.get(i)), i);
  }

  avg = sum/numColumns;
  avg_picks = sum_picks/column_picks.size();

  // sort the data or not
  if (sortSwitch == 1) culled_data.sortReverse();

  
  // label switch
  int labelIndex = -1;
  // int value_index = 0;
  int hover_index = 0;

  for (int i = 0; i < column_picks.size(); i++)
  {
    float this_data = culled_data.get(i);
    float this_data_sorted = culled_data_sorted.get(i);
    float maxRatio = this_data/culled_data.max();
    float sumRatio = this_data/sum_picks;
    float newVal = this_data*360/sum_picks;
    float endAngle = startAngle + radians(newVal);
    float newSize = chartRadius + (this_data*300)/sum_picks;
    
    int sorted_index = 0;
    int value_index = round(this_data);


    // get mouse position relative to sketch center
    float translateX = map(mouseX, 0, width, -width/2, width/2);
    float translateY = map(mouseY, 0, height, -height/2, height/2);

    // cartesian to polar coordinates
    float mouseRad = sqrt(pow(translateY, 2) + pow(translateX, 2));
    float mouseAngle = atan2(translateY, translateX);

    // fix for full circle
    if (mouseAngle < 0) {
      mouseAngle = PI + (PI + mouseAngle);
    }

    // mouse interaction
    colorMode(HSB);
    float fillColor = 255 * maxRatio;
    float fillAlpha = (fillColor*20)+20;
    if (((mouseAngle > startAngle) && (mouseAngle < endAngle)) 
          && (mouseRad < newSize * .5) && (mouseRad > innerCircleRadius * .5)) {
      // mouse over segment
      labelIndex = round(this_data);
      sorted_index = round(this_data_sorted);
      hover_index = paired_dewey_numbers.get(str(labelIndex));
      hoverTextSwitch = hover_index;
      if (sortSwitch == 1) fill(colorMapSelected[paired_values.get(str(sorted_index))]);
      if (sortSwitch == 0) fill(colorMapSelected[paired_values.get(str(value_index))]);

    }
    // fix for negative start angle values
    else if ( (startAngle < 0) && (mouseAngle > startAngle+(2*PI)) && (mouseAngle < 2*PI) 
                  && (mouseRad < newSize * .5) && (mouseRad > innerCircleRadius * .5))  {
      labelIndex = round(this_data);
      sorted_index = round(this_data_sorted);
      hover_index = paired_dewey_numbers.get(str(labelIndex));
      hoverTextSwitch = hover_index;
      if (sortSwitch == 1) fill(colorMapSelected[paired_values.get(str(sorted_index))]);
      if (sortSwitch == 0) fill(colorMapSelected[paired_values.get(str(value_index))]);

    } else {
      // mouse not over segment
      if (sortSwitch == 1) fill(colorMap[i]);
      if (sortSwitch == 0) fill(colorMap[paired_values.get(str(value_index))]);

    }
    colorMode(RGB);


    // draw the chart
    arc(width/2, height/2, newSize, newSize, startAngle, endAngle);
    
    // draw another partially transparent chart on top so colors change with month
    fill(colorMapMonth[round(avgColorPick)],55);
    arc(width/2, height/2, newSize, newSize, startAngle, endAngle);
    
    startAngle = endAngle;

    fill(bgColor);
    ellipse(width/2, height/2, innerCircleRadius, innerCircleRadius);
    
    // draw the label
    if (labelIndex != -1) {               
      String txt = str(labelIndex);
      float labelW = textWidth(txt);
      fill(tickColor);
      textFont(fontCenter);
      textAlign(CENTER,CENTER);
      text(txt, width/2, (height/2)-10);
    }
  
  }
}

